// ver 1.0.2
// 2021/12/22

        // https://developer.mozilla.org/ru/docs/Web/JavaScript/Reference/Classes/Public_class_fields
        let SecoCallTransactionResult;
        class SecoCall
        {
          constructor()
          {
            SecoCallTransactionResult = null;
            // Listen to messages from parent window
            this.bindEvent(window, 'message', async function (e)
            {
              if (e.origin.indexOf('extension://') >= 0)
              {
                SecoCallTransactionResult = e.data;
              }
            });
          }
          bindEvent(element, eventName, eventHandler)
          {
            if (element.addEventListener)
            {
                element.addEventListener(eventName, eventHandler, false);
            }
            else
            if (element.attachEvent)
            {
                element.attachEvent('on' + eventName, eventHandler);
            }
          }
          sendMessage(msg)
          {
            window.parent.postMessage(msg, '*');
          }
          async sendAmadeusCommand(amadeuscommand)
          {
            SecoCallTransactionResult = null;
            var msg = { amadeuscommand:amadeuscommand, mode:'execute' };
            this.sendMessage(msg);
            do
            {
              await new Promise(resolve => setTimeout(resolve, 50));
            } while (SecoCallTransactionResult == null)

            SecoCallTransactionResult = JSON.parse(SecoCallTransactionResult.replace(/\n/g, "\\\\n").replace(/\r/g, "\\\\r").replace(/\t/g, "\\\\t"));
            return SecoCallTransactionResult;
          }
          async getLastResponce()
          {
            SecoCallTransactionResult = null;
            var msg = { amadeuscommand:'*', mode:'last' };
            this.sendMessage(msg);
            do
            {
              await new Promise(resolve => setTimeout(resolve, 50));
            } while (SecoCallTransactionResult == null)

            SecoCallTransactionResult = JSON.parse(SecoCallTransactionResult.replace(/\n/g, "\\\\n").replace(/\r/g, "\\\\r").replace(/\t/g, "\\\\t"));
            return SecoCallTransactionResult;
          }
          async getAuthorizedUser()
          {
            SecoCallTransactionResult = null;
            var msg = { amadeuscommand:'get', mode:'user' };
            this.sendMessage(msg);
            do
            {
              await new Promise(resolve => setTimeout(resolve, 50));
            } while (SecoCallTransactionResult == null)

            //SecoCallTransactionResult = JSON.parse(SecoCallTransactionResult);
            return SecoCallTransactionResult;
          }
          async getHtmlResponce(requestmode, requestparams)
          {
            SecoCallTransactionResult = null;
            var msg = { amadeuscommand:requestparams, mode:requestmode };
            this.sendMessage(msg);
            do
            {
              await new Promise(resolve => setTimeout(resolve, 50));
            } while (SecoCallTransactionResult == null)

            return SecoCallTransactionResult;
          }
          async getLocalStorage(requestparams)
          {
            SecoCallTransactionResult = null;
            var msg = { amadeuscommand:requestparams, mode:'storagelocalget' };
            this.sendMessage(msg);
            do
            {
              await new Promise(resolve => setTimeout(resolve, 50));
            } while (SecoCallTransactionResult == null)

            return SecoCallTransactionResult;
          }
          async setLocalStorage(requestparams)
          {
            SecoCallTransactionResult = null;
            var msg = { amadeuscommand:requestparams, mode:'storagelocalset' };
            this.sendMessage(msg);
            do
            {
              await new Promise(resolve => setTimeout(resolve, 50));
            } while (SecoCallTransactionResult == null)

            return SecoCallTransactionResult;
          }
          async createNotifications(requestparams)
          {
            SecoCallTransactionResult = null;
            var msg = { amadeuscommand:requestparams, mode:'createnotifications' };
            this.sendMessage(msg);
            do
            {
              await new Promise(resolve => setTimeout(resolve, 50));
            } while (SecoCallTransactionResult == null)

            return SecoCallTransactionResult;
          }
        }
